#ifndef _CLIENT_H_

#define _CLIENT_H_

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "server.h"
#include "utility.h"
#include "config_file.h"
#include "chunkyircd.h"
#include "channel.h"
#include "ircd.h"

/* Main client routines */
int client_add(const char *, const char *, const char *);
int client_add_by_struct(ClientInfo);
int client_remove(const char *);
int client_unlink(const char *);
ClientInfo client_locate(const char *);
int client_free(ClientInfo);

/* Channel list stuff */
int client_rem_chan(ClientInfo, ChannelInfo);
int client_add_chan(ClientInfo, ChannelInfo);

/* Searches tree for clients connected via the server */
int clients_netsplit(ServerInfo, ServerInfo, char *);

/* Send a list of our clients to a new server */
int clients_introduce(ServerInfo);

int client_kill(ServerInfo, ServerInfo, ClientInfo, ClientInfo, char *);
/* Send a message to people with a certain mode set */
int clients_servnotice(char *);
/* Generate a client list for WHO replies */
int client_who_mask(char *, ClientInfo, ClientInfo, int);
/* Generate a names reply for clients not on any channel */
int clients_nochan_names(ClientInfo, ClientInfo, char *);

/* Used for masks for privmsg and notice */
void client_msg_by_server_mask(ClientInfo, char *, char *, char *,
			       ClientInfo);
void client_msg_by_host_mask(ClientInfo, char *, char *, char *,
			     ClientInfo);

#endif
